using System;
using System.Collections;
using UnityEngine;

namespace Experiment01
{
	public class Overloaded: MonoBehaviour {
		void Start()
		{
			pb = gameObject.GetComponent<PhysicalBehaviour>();
			StartCoroutine(Dropdown());
		}
		void FixedUpdate()
		{
			pb.Charge = 50f;
		}
IEnumerator Dropdown() {
      while (true) {
        yield
        return new WaitForSeconds(1.0f);
        timer--;
        //pinger.Brightness = 1;
        //audioSource.PlayOneShot(beepclip, 0.7F);
        //beep
        //pinger.Brightness = 0;
        if (timer == 0) {
			UnityEngine.Object.Destroy(this.light,2f);
           ExplosionCreator.CreateFragmentationExplosion(
            32, 
            transform.position, 
            4, 
            7, 
            true, 
            false, 
            0.5f);
        }
        yield
        return null;
      }
    }
	int timer = 5;
	public GameObject light;
	[SkipSerialisation]
	   public PhysicalBehaviour pb;
	}
	class OverloadPoison: PoisonSpreadBehaviour {

	  public override float SpreadSpeed {
	    get {
	      return 8f;
	    }
	  }

	  public override void Start() {
	    //if (Limb.name == "Head") {
	    if (Limb.gameObject.GetComponent < Overloaded > () == null) {
	      Overloaded overload = Limb.gameObject.AddComponent(typeof (Overloaded)) as Overloaded;
	      var light = ModAPI.CreateLight(Limb.gameObject.transform, new Color32(255, 69, 0, 255), 5, 2);
	      overload.light = light.gameObject;
	    }
	    //}
	  }

	  public OverloadPoison() {}
	}

	class OverloadInjector: AndroidInjectorBase {
	  public override Type GetPoisonType() {
	    return typeof (OverloadPoison);
	  }
	}
	class LifeInjector: AndroidInjectorBase {
	  public override Type GetPoisonType() {
	    return typeof (LifePoison);
	  }
	}
}
