using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
//using UnityEngine.UIElements;
using UnityEngine.Events;
using TMPro;
namespace Experiment01 {
  public class Mod {
	  public static bool DescriptionLogger = false;
    public static void Main() {

	  AddAndroidSyringe<LifeInjector>("Life", "An Android injector that contains a blueprints for healing nanobots.","lifethumb.png", "injectorglow.png",new Color32(255,255,255,255));
	  AddAndroidSyringe<OverloadInjector>("Overloading Virus", "An Android injector that overloads the internal generator of androids.","overloadthumb.png", "fortglow.png",new Color32(255,255,255,255));
	  //NEEDS REPLACEMENT AddAndroidSyringe<GunInjector>("Gun Deployment Virus", "Androids have guns,and they dont know they do.","gunthumb.png", "gunglow.png");
	  AddAndroidSyringe<StrengthInjector>("Ultra Strength", "An android injector that enhances the strength of androids.","strengththumb.png", "strengthglow.png",new Color32(255,255,255,255));
	  AddAndroidSyringe<KnockoutInjector>("Knockout", "An android injector that temporarily shuts down androids.","knockthumb.png", "knockoutglow.png",new Color32(255,255,255,255));
	  AddAndroidSyringe<AcidInjector>("Acid", "Potent acid somehow crammed in an USB.","knockthumb.png", "acidglow.png",new Color32(255,255,255,255));
	  AddAndroidSyringe<GiantizerInjector>("Growth", "It makes androids grow,what else do i say?","growththumb.png", "growthglow.png",new Color32(255,255,255,255));
	  AddAndroidSyringe<HeadInflator>("Head Inflation", "Big brain time.","hithumb.png", "headglow.png",new Color32(255,255,255,255));
	  AddAndroidSyringe<HeadPopInjector>("Head Popping", "The headless horseless androidman.","popthumb.png", "popglow.png",new Color32(255,255,255,255));
	  AddAndroidSyringe<WaterproofInjector>("Waterproofing", "Makes androids waterproof.","waterproofthumb.png", "waterproofglow.png",new Color32(255,255,255,255));
	  AddAndroidSyringe<PinkInjector>("Chaotic Pink", "This cant go well. Random effects.","pinkthumb.png", "pinkglow.png",new Color32(255,255,255,255));
	  AddAndroidSyringe<SplitInjector>("Split", "Splits.","splitt.png", "split.png",new Color32(255,255,255,255));
	  AddAndroidSyringe<WeightlessInjector>("Weightlessness", "Androids go weeeeeeeeeeeeeeeeeeeeeee","wt.png", "weightless.png",new Color32(255,255,255,255));
	  AddAndroidSyringe<ReflectInjector>("Laser Reflection", "Enables androids laser reflection capabalities.","lasert.png", "laser.png",new Color32(255,255,255,255));
	  AddAndroidSyringe<BouncyInjector>("Bouncy", "Bounce bounce bounce bounce","bouncet.png", "bounce.png",new Color32(255,255,255,255));
	  AddAndroidSyringe<SlipperyInjector>("Slippery", "Butter.","slipt.png", "slippery.png",new Color32(255,255,255,255));
	  AddAndroidSyringe<DeathInjector>("Death", "It makes androids die.","placeholder.png", "whiteglow.png",new Color32(20,0,0,255));
	  AddAndroidSyringe<KillerInjector>("Killer","Androids injected with this,become basically the most dangerous thing to touch.","placeholder.png","whiteglow.png",new Color32(255,0,0,255));
	  AddAndroidSyringe<RainbowInjector>("Rainbow","Androids injected with this thing somehow turn into a disco party?..","placeholder.png","rainbowglow.png",new Color32(255,255,255,255));
	  AddAndroidSyringe<TanglingInjector>("Snare","Ties the android together.","placeholder.png","rainbowglow.png",new Color32(255,198,255,255));
	  AddAndroidSyringe<MMInjector>("Minor Malfunction","Androids injected with this start malfunctioning for a short amount of time.","placeholder.png","whiteglow.png",new Color32(255,255,255,255));
	  AddAndroidSyringe<DwarfInjector>("Dwarfing","Makes the android smaller.","placeholder.png","rainbowglow.png",new Color32(255,198,255,255));
	  /// 21/50
    }
    public static void AddAndroidSyringe < T > (string syringename, string description, string thumbnail, string glowname, Color32 tint) where T: AndroidInjectorBase {
		if(DescriptionLogger){Debug.Log("[*]"+syringename+" Injector"+" : "+description);}
      //Android Syringe
      ModAPI.Register(
        new Modification() {
          OriginalItem = ModAPI.FindSpawnable("Rod"),
            NameOverride = syringename + " Injector",
            CategoryOverride = ModAPI.FindCategory("Biohazard"),
            DescriptionOverride = description,
            ThumbnailOverride = ModAPI.LoadSprite(thumbnail, 5f),
            AfterSpawn = (Instance) => {
              var phys = Instance.GetComponent < PhysicalBehaviour > ();
              phys.Disintegratable = false;
              Instance.GetComponent < SpriteRenderer > ().sprite = ModAPI.LoadSprite("ainjbase.png");
              Instance.FixColliders();
              var childObject = new GameObject("glow");
              childObject.transform.SetParent(Instance.transform);
              childObject.transform.position = Instance.transform.position;
			  childObject.transform.rotation = Quaternion.identity;
              childObject.transform.localPosition = new Vector3(0f, 0f);
              childObject.transform.localScale = new Vector3(1f, 1f);
              var childSprite = childObject.AddComponent < SpriteRenderer > ();
              childSprite.sprite = ModAPI.LoadSprite(glowname);
              childSprite.sortingLayerName = "Top";
			  //if(tint != new Color32(255,255,255,255))
			  //{
				  childSprite.color = tint;
			  //}
              childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
              var injector = Instance.AddComponent(typeof (T)) as T;
              injector.audioSource = Instance.AddComponent(typeof (AudioSource)) as AudioSource;
              injector.clip1 = ModAPI.LoadSound("start.wav");
              injector.clip2 = ModAPI.LoadSound("finish.wav");
            }
        }
      );
    }
  }
}